package com.example.demo;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/api/new")
public class ApiController {
    private final Logger log = LoggerFactory.getLogger(ApiController.class);
    private LinkedHashMap<Integer, TestDto> map = new LinkedHashMap<>();
    int id = 0;

    @GetMapping("/map")
    public List<TestDto> getAll() {
        return new ArrayList<>(map.values());
    }

    @GetMapping("/{id}")
    public TestDto get(@PathVariable(name = "id") int id) {
        return map.get(id);
    }

    @PostMapping("/map")
    public TestDto create(@RequestBody TestDto data) {
        map.put(id, data);
        ++id;
        return data;
    }

    @PutMapping("/{id}")
    public TestDto update(@PathVariable(name = "id") int id, @RequestBody TestDto data) {
        log.info("The body value is {}", data);
        if (map.containsKey(id)) {
            map.put(id, data);
        }
        return get(id);
    }

    @DeleteMapping("/{id}")
    public TestDto delete(@PathVariable(name = "id") int id) {
        return map.remove(id);
    }

}
